            #include <P16F628A.INC>
            LIST        p=16F628A     
            __CONFIG    H'3F10'             ; 
                                              
Sec           equ         20h               ;    
Sec1          equ         21h               ; 
Sec2          equ         22h               ;
scetbit       equ         23h               ;      spi
shet          equ         24h               ;    
scetbit_1     equ         25h               ;  
var           equ         26h               ;    
byte_H        equ         27h               ;     
byte_L        equ         28h               ; 
knp_kod       equ         29h               ;              
edin          equ         2Ah               ;   
desiat        equ         2Bh               ; 
sotni         equ         2Ch               ;
dat_ind       equ         2Dh               ;      spi
adr_ind       equ         2Eh               ;      spi
       
flag          equ         7Dh               ;  
W_TEMP        equ         7Eh               ;     W
STATUS_TEMP   equ         7Fh               ;    STATUS

#DEFINE       regim       PORTB,2           ;  8/16 
#DEFINE       scl         PORTB,3           ;  SCL
#DEFINE       sdo         PORTB,4           ;  SDO

#DEFINE       datai       PORTB,5           ;    MAX7219
#DEFINE       cs          PORTB,6           ;   MAX7219
#DEFINE       clk         PORTB,7           ;   MAX7219


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              org         0000h             ;     0000h
              goto        Start             ;   Start

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  

              org         0004h             ;     0004h
                      
              movwf       W_TEMP            ;   
              swapf       STATUS,W          ;
              clrf        STATUS            ;
              movwf       STATUS_TEMP       ;

              btfss       sdo               ;  sdo
              goto        exxit             ; .  sdo:    exxit
met_int1      btfsc       sdo               ; .  sdo:     
              goto        met_int1          ;   met_int1

              movlw       .4                ; 13     Tw
              movwf       shet              ;
met_int2      decfsz      shet,F            ;
              goto        met_int2          ;
       
              bcf         flag,1            ;   2-  
met_int7      movlw       .8                ;    8-  
              movwf       scetbit_1         ;
met_int5      rrf         byte_H,F          ;  byte_H,    
              rrf         byte_L,F          ;  byte_L,    
              bsf         scl               ;  scl  1

              movlw       .2                ; 7 
              movwf       shet              ;
met_int3      decfsz      shet,F            ;
              goto        met_int3          ;
           
              bcf         scl               ;  scl  0

              movlw       .2                ; 7 
              movwf       shet              ;
met_int4      decfsz      shet,F            ;
              goto        met_int4          ;

              btfsc       sdo               ;  sdo,     
              bsf         byte_H,7          ; 7-   byte_H
              btfss       sdo               ;
              bcf         byte_H,7          ;
              decfsz      scetbit_1,F       ;  
              goto        met_int5          ;   :    met_int5

              btfsc       flag,1            ;   2-  
              goto        knp_16            ; 2- :    knp_16

met_int6      btfss       regim             ;  regim ( SA1)
              goto        knp_8             ; 8  ,  :    knp_8
              bsf         flag,1            ; 16  ,  ,    2-  
              goto        met_int7          ;   met_int7,   2- 

knp_8         movlw       .8                ;        (8 )  
              movwf       knp_kod           ;  byte_H
knp_8_1       btfsc       byte_H,7          ;
              goto        exxit_1           ;
              bcf         STATUS,C          ;
              rlf         byte_H,F          ;
              decfsz      knp_kod,F         ;
              goto        knp_8_1           ;
              goto        exxit             ;   exxit

knp_16        movlw       .16               ;        (16 ) 
              movwf       knp_kod           ;  byte_H, byte_L
knp_16_1      btfsc       byte_H,7          ;
              goto        exxit_1           ;
              bcf         STATUS,C          ;
              rlf         byte_L,F          ;
              rlf         byte_H,F          ;
              decfsz      knp_kod,F         ;
              goto        knp_16_1          ;
              goto        exxit             ;   exxit
              
exxit_1       bsf         flag,0            ;    
exxit         movf        PORTB,W           ;  B    
              bcf         INTCON,RBIF       ;       RB4-RB7
                                          
              swapf       STATUS_TEMP,W     ;  STATUS  W
              movwf       STATUS            ;
              swapf       W_TEMP,F          ;
              swapf       W_TEMP,W          ;
              retfie                        ;   

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
                                       
Start         movlw       b'01000000'       ;    B
              movwf       PORTB             ;
              
              movlw       b'00000111'       ; 
              movwf       CMCON             ;

              bsf         STATUS,RP0        ; 1-     
              movlw       b'00010111'       ;  \  B  
              movwf       TRISB             ;
              bcf         STATUS,RP0        ; 0-    

              clrf        flag              ;   

              movf        PORTB,W           ;  B    
              bcf         INTCON,RBIF       ;       RB4-RB7
              bsf         INTCON,RBIE       ;    RB4-RB7
              bsf         INTCON,GIE        ;  
                 
              call        init_lcd          ;   (MAX7219) 
              call        signal_not        ;     "- -"  1,2 

met_1         btfss       flag,0            ;    
              goto        met_1             ;   met_1
              bcf         flag,0            ;    
              
              call        vivod             ;       
              goto        met_1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;        
                               
vivod         movf        knp_kod,W         ;      var
              movwf       var               ;
              call        razryad           ;       
                                            ; 
              movlw       0x01              ;       1- 
              movwf       adr_ind           ;
              movf        edin,W            ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x02              ;      2- 
              movwf       adr_ind           ;
              movf        desiat,W          ;
              movwf       dat_ind           ;
              call        send              ;
              return                        ;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                       
;       ,    var
;  sotni,   desiat,   edin

razryad       clrf        sotni             ;
pr0           incf        sotni,F           ; 
              movlw       .100              ;
              subwf       var,F             ;
              btfsc       STATUS,C          ;
              goto        pr0               ;
              decf        sotni,F           ;
              movlw       .100              ;
              addwf       var,F             ;
              clrf        desiat            ;
pr1           incf        desiat,F          ; 
              movlw       .10               ;
              subwf       var,F             ;
              btfsc       STATUS,C          ;
              goto        pr1               ;
              decf        desiat,F          ;
              movlw       .10               ;
              addwf       var,F             ;
              clrf        edin              ;
pr2           incf        edin,F            ; 
              movlw       .1                ;
              subwf       var,F             ;
              btfsc       STATUS,C          ;
              goto        pr2               ;
              decf        edin,F            ;
              return                        ;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     1,2 
        
signal_not    movlw       0x08              ; 8- 
              movwf       adr_ind           ;
              movlw       0x0F              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x07              ; 7- 
              movwf       adr_ind           ;
              movlw       0x0F              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x06              ; 6- 
              movwf       adr_ind           ;
              movlw       0x0F              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x05              ; 5- 
              movwf       adr_ind           ;
              movlw       0x0F              ;
              movwf       dat_ind           ;
              call        send              ; 
              movlw       0x04              ; 4- 
              movwf       adr_ind           ;
              movlw       0x0F              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x03              ; 3- 
              movwf       adr_ind           ;
              movlw       0x0F              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x02              ;   2- 
              movwf       adr_ind           ;
              movlw       0x0A              ;
              movwf       dat_ind           ;
              call        send              ;
              movlw       0x01              ;   1- 
              movwf       adr_ind           ;
              movlw       0x0A              ;
              movwf       dat_ind           ;
              call        send              ;
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  (MAX7219)  

init_lcd      call        pauslcd           ;   2 
              movlw       0x0F              ;  
              movwf       adr_ind           ;
              movlw       0x00              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x0C              ; 
              movwf       adr_ind           ;
              movlw       0x01              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x0A              ; 15/32
              movwf       adr_ind           ;
              movlw       0x07              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x09              ; BCD Code B   
              movwf       adr_ind           ;
              movlw       0xFF              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x0B              ; 8 
              movwf       adr_ind           ;
              movlw       0x07              ;
              movwf       dat_ind           ;
              call        send              ;
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  2-    (MAX7219)     SPI

send          bcf         cs                ;    CS
              movlw      .8                 ;    adr_ind
              movwf      scetbit            ;
povtor        bcf        clk                ;
              btfsc      adr_ind,7          ;
              bsf        datai              ;
              btfss      adr_ind,7          ;
              bcf        datai              ;
              bsf        clk                ;
              rlf        adr_ind,F          ;
              decfsz     scetbit,F          ;
              goto       povtor             ;
             
              movlw      .8                 ;    dat_ind
              movwf      scetbit            ;
povtr1        bcf        clk                ;
              btfsc      dat_ind,7          ;
              bsf        datai              ;
              btfss      dat_ind,7          ;
              bcf        datai              ;
              bsf        clk                ;
              rlf        dat_ind,F          ;
              decfsz     scetbit,F          ;
              goto       povtr1             ;
              bcf        clk                ;
              bsf        cs                 ;  1    CS                 
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

pauslcd       movlw       .4                ;  2 
              movwf       Sec1              ;
p_l2          movlw       .166              ;
              movwf       Sec               ;
p_l1          decfsz      Sec,F             ;
              goto        p_l1              ;
              decfsz      Sec1,F            ;
              goto        p_l2              ;
              return                        ;  

pause         movlw       .25               ;
              movwf       Sec2              ;
p_3           movlw       .255              ;  5 
              movwf       Sec1              ;
p_1           movlw       .255              ;
              movwf       Sec               ;
p_2           decfsz      Sec,F             ;
              goto        p_2               ;
              decfsz      Sec1,F            ;
              goto        p_1               ;
              decfsz      Sec2,F            ;
              goto        p_3               ;
              return                        ;  
                           
              end                           ;  
                                            ;
